#!/usr/bin/perl

# Generates LaTeX Slackware labels.

# For a 10 x 3 grid of 2.65 x 1 inch labels
# such as Office Essentials (Avery) 3330, or Z-Label 01560
# (eg. MEI/Micro Center SKU#4016)

# This program doesn't know about multiple sheets.
# You just split up the file list manually and run it twice.

$cols = $across = 3;
while ( $fline = <STDIN> ) {
  chop $fline;
  if ( $fline =~ /\/[a-z_]+[0-9]\/.+tgz$/ ) {
    @tmp = split( /\//, $fline );
    ($disk, $basename) = (@tmp[ $#tmp  - 1 ], @tmp[ $#tmp ]);
    $basename =~ s/\.tgz$//;
    $disk =~ s/_//;
    $db{ $disk } .= "$basename ";
  }
}

open ( OF, ">$ARGV[0]" ) || die "expected to create $ARGV[0], dying!\n";

$preamble =<<"zlor";
\\documentstyle{article}
\\setlength{\\voffset}{-25.6 mm}
\\setlength{\\hoffset}{-31.5 mm}
\\setlength{\\textwidth}{216 mm}  % zero margins!
\\setlength{\\textheight}{279.1 mm}
\\setlength{\\topmargin}{0cm}
\\setlength{\\headheight}{0cm}
\\setlength{\\headsep}{0cm}
\\setlength{\\topskip}{0cm}
\\setlength{\\oddsidemargin}{0cm}
\\setlength{\\evensidemargin}{\\oddsidemargin}
\\setlength{\\parskip}{3 ex}
\\pagestyle{empty}
\\setlength{\\unitlength}{0.1 cm}

\\begin{document}
\\newfont{\\nf}{cmbx6}
% \\nf
\\begin{picture}(216,279) %  The whole page is a picture!
zlor

$t1 = <<'zlor';
\makebox( 63, 24.5 )[tl]{
 \parbox{62.5 mm}{
  \vspace{2 mm}
  \mbox{
   \hspace{1mm}
    {\bf SLACKWARE 2.0}
   \hspace{2 mm}
   \fbox{ disk
zlor
chop $t1;

print OF $preamble;
$yyreset = 12.5;
$diskn = 1; $xx = 7; $yy = $yyreset;

foreach $disk (sort(keys %db)){
  $pos = 1;
  foreach $file (split ( / /, $db{$disk} )) {
    $file =~ s/_/\\_/g;
    $table{ $disk } .=  "$file " ;
    $pos++;
  }
  print OF ("\\put( $xx, $yy ){$t1 {\\bf $disk}}\n",
           "   }\n\n",
           "   \\\parbox{ 61.2 mm }{\n\n",
           "     ".$table{$disk}."\n",
           "   }\n   }\n }\n}\n");
  if ( 0 == ($diskn % 10) ) {
    $xx += 69; $yy = $yyreset;
  } else {
    $yy += 25.4;
  }
  $diskn++;
}
# if ( !($diskn % 30) ) {
  print OF ("\n\\end{picture}\\end{document}\n");
# }
